---
name: Bug report
about: Create a bug/issue report to contribute and get support
title: ''
labels: ''
assignees: ''

---

It is important to describe your problem clear enough in order to have a more efficient solution process. 

Your description must include hardware info, detailed explanation of your problem,  shortest code block to reproduce the error, expected behavior of the code block, exact error message and screenshots (if applicable). 

------------------------------------------------ remove above ------------------------------------------------

### Hardware:
Board | : | Deneyap Kart
----- | - | ------------
Core version | : | 1.0.0 or ?
IDE | : | Arduino IDE or ?
Computer OS | : | Win or ?
Upload mode | : | auto or manual ?
Upload speed | : | 921600 or ?
CPU frequecny | : | 240MHz or ?
Flash frequency | : | 40MHz or 80MHz ?
Flash mode | : | qio or ?
Partition scheme | : | default or ?

### Description:
Describe your problem here.

### Sketch to reproduce the error:  
```cpp
//Change the code below by your sketch
#include <Arduino.h>

void setup() {
}

void loop() {
}
```

**Steps to reproduce the behavior:**
1. Go to '...'
2. Click on '....'
3. Scroll down to '....'
4. See error

### Expected behavior:
A clear and concise description of what you expected to happen.

### Debug Messages:
```
Enable Core debug level: Debug on tools menu of Arduino IDE, then put the serial output here. 
```

### Screenshots:
If applicable, add screenshots to help explain your problem.

### Additional context:
Add any other context about the problem here.
